mod Maux12b

incl Maux12

incl Mtesting12

appldisp/2 Tex2_gnd_std
  Std('Gnd',0)

appldisp/2 Tex2_gnd
  Frac(Arg(0),1,Arg(1))

appldisp/1 Tex1_gsz
  Fenced(Op(Ent('mid'),0),Arg(0),Op(Ent('mid'),0))

appldisp/1 Tex1_gszl
  Subsup(Fenced(Op(Ent('mid'),0),Arg(0),Op(Ent('mid'),0)),75,Id(0,'L',0),None)

appldisp/1 Tex1_gdp
  Std('d',0)

appldisp/1 Tex1_gdpl
  Prefix(90,2,Subsup(Id(0,'d',0),99,Id(0,'L',0),None),Arg(0))

appldisp/2 Tex2_ingt
  Infix(Arg(0),25,0,Op(Ent('isin'),0),Arg(1))

appldisp/2 Tex2_ingtl
  Infix(Arg(0),25,0,Subsup(Op(Ent('isin'),0),75,Id(0,'L',0),None),Arg(1))

appldisp/2 Tex2_ingt_
  Infix(Arg(0),25,0,Subsup(Op(Ent('isin'),0),75,Op('*',0),None),Arg(1))

appldisp/2 Tex2_isomorphic
  Infix(Arg(0),25,0,Op(Ent('sime'),0),Arg(1))

appldisp/2 Tex2_isomorphicl
  Infix(Arg(0),25,0,Subsup(Op(Ent('sime'),0),75,Id(0,'L',0),None),Arg(1))

appldisp/1 Tex1_reflectl
  Prefix(90,2,Subsup(Id(0,'Reflect',0),99,Id(0,'L',0),None),Arg(0))

appldisp/2 Tex2_reflectal
  Prefix(90,2,Subsup(Id(0,'Reflecta',0),99,Id(0,'L',0),None),
         Fenced(Op('(',0),Infix(Arg(0),30,2,Op(',',0),Arg(1)),Op(')',0)))

appldisp/1 Tex1_preorderl
  Prefix(90,2,Subsup(Id(0,'Preorder',0),99,Id(0,'L',0),None),Arg(0))

appldisp/1 Tex1_postorderl
  Prefix(90,2,Subsup(Id(0,'Postorder',0),99,Id(0,'L',0),None),Arg(0))

appldisp/2 Tex2_preorderal
  Prefix(90,2,Subsup(Id(0,'Preordera',0),99,Id(0,'L',0),None),
         Fenced(Op('(',0),Infix(Arg(0),30,2,Op(',',0),Arg(1)),Op(')',0)))

appldisp/2 Tex2_postorderal
  Prefix(90,2,Subsup(Id(0,'Postordera',0),99,Id(0,'L',0),None),
         Fenced(Op('(',0),Infix(Arg(0),30,2,Op(',',0),Arg(1)),Op(')',0)))

appldisp/2 Tex2_num_prel
  Prefix(90,2,Subsup(Id(0,'Num_pre',0),99,Id(0,'L',0),None),
         Fenced(Op('(',0),Infix(Arg(0),30,2,Op(',',0),Arg(1)),Op(')',0)))

appldisp/2 Tex2_num_postl
  Prefix(90,2,Subsup(Id(0,'Num_post',0),99,Id(0,'L',0),None),
         Fenced(Op('(',0),Infix(Arg(0),30,2,Op(',',0),Arg(1)),Op(')',0)))

appldisp/1 Tex1_fl
  Prefix(90,2,Subsup(Id(0,'f',0),99,Id(0,'L',0),None),Arg(0))

rem 
  \para \bf  Konštruktor všeobecných stromov  \end 

fun/2 Gnd 'Tex2_gnd'
  Gnd(x,ts) = 1,x,ts

rem 
  \para \bf  Formát stromov obsahujúcich znaky  \end 

pred Lgtc 
  Lgtc(0)
  Lgtc(Gnd(x1,ts1),ts2) <- Ch(x1) & Lgtc(ts1) & Lgtc(ts2)

pred Gtc 
  Gtc Gnd(x,ts) <- Ch(x) & Lgtc(ts)

rem 
  \para \bf  Formát výsledkov testov so stromami obsahujúcimi znaky  \end 

pred Results_lgtc 
  Results_lgtc(0)
  Results_lgtc(Result_ok(x,y,t),rs) <- 
    Lgtc(x) & Lgtc(y) & Type(t) & Results_lgtc(rs)
  Results_lgtc(Result_failed(x,y,t),rs) <- 
    Lgtc(x) & Lgtc(y) & Type(t) & Results_lgtc(rs)

pred Results_gtc 
  Results_gtc(0)
  Results_gtc(Result_ok(x,y,t),rs) <- 
    Gtc(x) & Gtc(y) & Type(t) & Results_gtc(rs)
  Results_gtc(Result_failed(x,y,t),rs) <- 
    Gtc(x) & Gtc(y) & Type(t) & Results_gtc(rs)

rem 
  \para \bf  Syntaktické stromy aplikačných výrazov  \end 

rem 
  \para \it  Konštrukcia syntaktického stromu pre daný výraz  \end 

pred Literal 
  Literal(x) <-> "a" <= x & x <= "z"

fun S2gtcl 'Tex_f1_gt_s2gtcl'
  S2gtcl(0) = 0,0
  S2gtcl(x,xs) = (Gnd(x,ts1),ts2),ys <- 
    Literal(x) & S2gtcl(xs) = ts1,zs & S2gtcl(zs) = ts2,ys
  S2gtcl(x,xs) = ts,ys <- ~Literal(x) & x = "(" & S2gtcl(xs) = ts,ys
  S2gtcl(x,xs) = 0,xs <- ~Literal(x) & x = ")"
  S2gtcl(x,xs) = 0,xs <- ~Literal(x) & x = ","

fun S2gtc 
  S2gtc(x,xs) = Gnd(x,ts) <- S2gtcl(xs) = ts,ys

rem 
  \para \it  Zobrazenie stromu znakov vo forme výrazu  \end 

fun Lgtc2s 
  Lgtc2s(Gnd(x1,0),ts2) = x1,0 <- Lgtc2s(0) = s1 & ts2 = 0
  Lgtc2s(Gnd(x1,0),ts2) = (x1,0)++','++s2 <- 
    Lgtc2s(0) = s1 & ts2 != 0 & Lgtc2s(ts2) = s2
  Lgtc2s(Gnd(x1,ts1),ts2) = (x1,0)++'('++s1++')' <- 
    ts1 != 0 & Lgtc2s(ts1) = s1 & ts2 = 0
  Lgtc2s(Gnd(x1,ts1),ts2) = (x1,0)++'('++s1++'),'++s2 <- 
    ts1 != 0 & Lgtc2s(ts1) = s1 & ts2 != 0 & Lgtc2s(ts2) = s2

fun Gtc2s 
  Gtc2s Gnd(x,0) = x,0
  Gtc2s Gnd(x,ts) = (x,0)++'('++Lgtc2s(ts)++')' <- ts != 0

